Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 728)
+++ src/mlx/gui/flight.py	(revision 764)
@@ -1600,8 +2166,8 @@
         if self._wizard.gui.config.useSimBrief and \
            self._wizard.usingSimBrief is not False:
-            self._wizard.nextPage()
+            self._wizard.jumpPage("simbrief_setup")
         else:
             self._wizard.usingSimBrief = False
-            self._wizard.jumpPage(3)
+            self._wizard.jumpPage("fuel")
 
 #-----------------------------------------------------------------------------
@@ -1762,5 +2328,5 @@
         """Construct the setup page."""
 
-        super(SimBriefSetupPage, self).__init__(wizard,
+        super(SimBriefSetupPage, self).__init__(wizard, "simbrief_setup",
                                                 xstr("simbrief_setup_title"),
                                                 xstr("simbrief_setup_help"),
@@ -2081,5 +2647,5 @@
 
                 self._wizard.usingSimBrief = False
-                self._wizard.jumpPage(2, fromPageShift = 1)
+                self._wizard.jumpPage("fuel", fromPageShift = 1)
 
     def _getPlan(self):
@@ -2166,5 +2732,5 @@
         """Construct the setup page."""
 
-        super(SimBriefingPage, self).__init__(wizard,
+        super(SimBriefingPage, self).__init__(wizard, "simbrief_result",
                                               xstr("simbrief_result_title"), "")
 
@@ -2422,5 +2988,6 @@
     def __init__(self, wizard):
         """Construct the page."""
-        super(FuelPage, self).__init__(wizard, xstr("fuel_title"),
+        super(FuelPage, self).__init__(wizard, "fuel",
+                                       xstr("fuel_title"),
                                        xstr("fuel_help_pre") +
                                        xstr("fuel_help_post"),
@@ -2474,7 +3041,7 @@
             self._pump()
         elif self._wizard.usingSimBrief:
-            self._wizard.jumpPage(3)
+            self._wizard.jumpPage("takeoff")
         else:
-            self._wizard.nextPage()
+            self._wizard.jumpPage("briefing1")
 
     def _setupTanks(self, tankData):
@@ -2522,5 +3089,5 @@
             if self._wizard.usingSimBrief:
                 self._wizard.gui.startMonitoring()
-                self._wizard.jumpPage(3)
+                self._wizard.jumpPage("takeoff")
             else:
                 bookedFlight = self._wizard._bookedFlight
@@ -2591,9 +3158,13 @@
         self._departure = departure
 
-        title = xstr("briefing_title") % (1 if departure else 2,
+        number = 1 if departure else 2
+
+        title = xstr("briefing_title") % (number,
                                           xstr("briefing_departure")
                                           if departure
                                           else xstr("briefing_arrival"))
-        super(BriefingPage, self).__init__(wizard, title, xstr("briefing_help"),
+        super(BriefingPage, self).__init__(wizard,
+                                           "briefing%d" % (number,),
+                                           title, xstr("briefing_help"),
                                            completedHelp = xstr("briefing_chelp"))
 
@@ -2782,5 +3353,6 @@
     def __init__(self, wizard):
         """Construct the takeoff page."""
-        super(TakeoffPage, self).__init__(wizard, xstr("takeoff_title"),
+        super(TakeoffPage, self).__init__(wizard, "takeoff",
+                                          xstr("takeoff_title"),
                                           xstr("takeoff_help"),
                                           completedHelp = xstr("takeoff_chelp"))
@@ -3270,5 +3842,6 @@
     def __init__(self, wizard):
         """Construct the page."""
-        super(CruisePage, self).__init__(wizard, xstr("cruise_title"),
+        super(CruisePage, self).__init__(wizard, "cruise",
+                                         xstr("cruise_title"),
                                          xstr("cruise_help"))
 
@@ -3384,5 +3957,6 @@
     def __init__(self, wizard):
         """Construct the landing page."""
-        super(LandingPage, self).__init__(wizard, xstr("landing_title"),
+        super(LandingPage, self).__init__(wizard, "landing",
+                                          xstr("landing_title"),
                                           xstr("landing_help"),
                                           completedHelp = xstr("landing_chelp"))
@@ -3698,5 +4272,6 @@
         """Construct the finish page."""
         help = xstr("finish_help") + xstr("finish_help_goodtime")
-        super(FinishPage, self).__init__(wizard, xstr("finish_title"), help)
+        super(FinishPage, self).__init__(wizard, "finish",
+                                         xstr("finish_title"), help)
 
         alignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
@@ -4256,4 +4831,6 @@
         self._pages.append(FlightSelectionPage(self))
         self._pages.append(GateSelectionPage(self))
+        self._pages.append(RegisterPage(self))
+        self._pages.append(StudentPage(self))
         self._pages.append(ConnectPage(self))
         self._payloadPage = PayloadPage(self)
@@ -4328,5 +4905,5 @@
     def entranceExam(self):
         """Get whether an entrance exam is about to be taken."""
-        return self._loginPage.entranceExam
+        return self._loginResult is not None and self._loginResult.rank=="STU"
 
     @property
@@ -4551,9 +5128,14 @@
     def nextPage(self, finalize = True):
         """Go to the next page."""
-        self.jumpPage(1, finalize)
-
-    def jumpPage(self, count, finalize = True, fromPageShift = None):
+        nextPageID = self._pages[self._currentPage].nextPageID
+        self.jumpPage(1 if nextPageID is None else nextPageID, finalize)
+
+    def jumpPage(self, countOrID, finalize = True, fromPageShift = None):
         """Go to the page which is 'count' pages after the current one."""
-        self.setCurrentPage(self._currentPage + count,
+        if isinstance(countOrID, str):
+            targetIndex = self._getIndexOf(countOrID)
+        else:
+            targetIndex = self._currentPage + countOrID
+        self.setCurrentPage(targetIndex,
                             finalize = finalize, fromPageShift = fromPageShift)
 
@@ -4616,5 +5198,5 @@
         #self.setCurrentPage(10)
 
-    def login(self, callback, pilotID, password, entranceExam):
+    def login(self, callback, pilotID, password):
         """Called when the login button was clicked."""
         self._loginCallback = callback
@@ -4624,5 +5206,4 @@
             pilotID = loginResult.pilotID
             password = loginResult.password
-            entranceExam = loginResult.entranceExam
             busyMessage = xstr("reload_busy")
         else:
@@ -4633,6 +5214,5 @@
 
         self.gui.webHandler.login(self._loginResultCallback,
-                                  pilotID, password,
-                                  entranceExam = entranceExam)
+                                  pilotID, password)
 
     def reloadFlights(self, callback):
@@ -4682,5 +5262,4 @@
         """Handle the login result."""
         self.gui.endBusy()
-        returned = True
         isReload = self._loginResult is not None
         if returned:
@@ -4788,3 +5367,13 @@
                 self._arrivalBriefingPage.setMETAR(metar)
 
+    def _getIndexOf(self, pageID):
+        """Get the index for the given page ID.
+
+        It is an assertion failure if the ID is not found."""
+        for index in range(0, len(self._pages)):
+            page = self._pages[index]
+            if page.id==pageID:
+                return index
+        assert False
+
 #-----------------------------------------------------------------------------
Index: src/mlx/gui/gui.py
===================================================================
--- src/mlx/gui/gui.py	(revision 733)
+++ src/mlx/gui/gui.py	(revision 755)
@@ -90,5 +90,10 @@
         self._sendBugReportCallback = None
 
-        self.webHandler = web.Handler()
+        self._credentialsCondition = threading.Condition()
+        self._credentialsAvailable = False
+        self._credentialsUserName = None
+        self._credentialsPassword = None
+
+        self.webHandler = web.Handler(config, self._getCredentialsCallback)
         self.webHandler.start()
 
@@ -442,4 +447,6 @@
                                     self._mainWindow)
             self._updater.start()
+        else:
+            self.updateDone()
 
         cef.initialize(self._programDirectory, self._cefInitialized)
@@ -452,4 +459,8 @@
 
         self._disconnect()
+
+    def updateDone(self):
+        """Called when the update is done (and there is no need to restart)."""
+        gobject.idle_add(self._updateDone)
 
     def connected(self, fsType, descriptor):
@@ -1635,2 +1646,78 @@
         """Set the anti-ice on indicator."""
         self._wizard.landingAntiIceOn = value
+
+    def _getCredentialsCallback(self):
+        """Called when the web handler asks for the credentials."""
+        # FIXME: this is almost the same as
+        # SimBriefSetupPage._getCredentialsCallback
+        with self._credentialsCondition:
+            self._credentialsAvailable = False
+
+            gobject.idle_add(self._getCredentials)
+
+            while not self._credentialsAvailable:
+                self._credentialsCondition.wait()
+
+            return (self._credentialsUserName, self._credentialsPassword)
+
+    def _getCredentials(self):
+        """Get the credentials."""
+        # FIXME: this is almost the same as
+        # SimBriefSetupPage._getCredentials
+        with self._credentialsCondition:
+            config = self.config
+
+            dialog = CredentialsDialog(self, config.pilotID, config.password,
+                                       xstr("login_title"),
+                                       xstr("button_cancel"),
+                                       xstr("button_ok"),
+                                       xstr("label_pilotID"),
+                                       xstr("login_pilotID_tooltip"),
+                                       xstr("label_password"),
+                                       xstr("login_password_tooltip"),
+                                       xstr("login_info"),
+                                       config.rememberPassword,
+                                       xstr("remember_password"),
+                                       xstr("login_remember_tooltip"))
+            response = dialog.run()
+
+            if response==RESPONSETYPE_OK:
+                self._credentialsUserName = dialog.userName
+                self._credentialsPassword = dialog.password
+                rememberPassword = dialog.rememberPassword
+
+                config.pilotID = self._credentialsUserName
+
+                config.password = \
+                  self._credentialsPassword if rememberPassword else ""
+                config.rememberPassword = rememberPassword
+
+                config.save()
+            else:
+                self._credentialsUserName = None
+                self._credentialsPassword = None
+
+            self._credentialsAvailable = True
+            self._credentialsCondition.notify()
+
+    def _updateDone(self):
+        """Called when the update is done.
+
+        It checks if we already know the PID, and if not, asks the user whether
+        to register."""
+        if not self.config.pilotID and not self.config.password:
+            dialog = gtk.MessageDialog(parent = self._mainWindow,
+                                       type = MESSAGETYPE_QUESTION,
+                                       message_format = xstr("register_ask"))
+
+            dialog.set_title(WINDOW_TITLE_BASE)
+            dialog.format_secondary_markup(xstr("register_ask_sec"))
+
+            dialog.add_button(xstr("button_cancel"), 0)
+            dialog.add_button(xstr("button_register"), 1)
+            dialog.set_default_response(1)
+
+            result = dialog.run()
+            dialog.hide()
+            if result == 1:
+                self._wizard.jumpPage("register")
Index: src/mlx/gui/prefs.py
===================================================================
--- src/mlx/gui/prefs.py	(revision 684)
+++ src/mlx/gui/prefs.py	(revision 738)
@@ -276,4 +276,6 @@
 
         self._updateURL.set_text(config.updateURL)
+
+        self._useRPC.set_active(config.useRPC)
 
         self._settingFromConfig = False
@@ -320,4 +322,5 @@
         config.autoUpdate = self._autoUpdate.get_active()
         config.updateURL = self._updateURL.get_text()
+        config.useRPC = self._useRPC.get_active()
 
     def _buildGeneral(self):
@@ -814,4 +817,10 @@
         updateURLBox.pack_start(self._updateURL, True, True, 4)
 
+        self._useRPC = gtk.CheckButton(xstr("prefs_use_rpc"))
+        mainBox.pack_start(self._useRPC, False, False, 16)
+
+        self._useRPC.set_use_underline(True)
+        self._useRPC.set_tooltip_text(xstr("prefs_use_rpc_tooltip"))
+
         return mainAlignment
 
Index: src/mlx/gui/update.py
===================================================================
--- src/mlx/gui/update.py	(revision 300)
+++ src/mlx/gui/update.py	(revision 755)
@@ -124,4 +124,5 @@
         if not self._waitAfterFinish:
             gobject.idle_add(self._progressWindow.hide)
+            self._gui.updateDone()
 
     def downloadingManifest(self):
@@ -286,4 +287,6 @@
         if self._restart:
             self._gui.restart()
+        else:
+            self._gui.updateDone()
 
 #-------------------------------------------------------------------------------
Index: src/mlx/pirep.py
===================================================================
--- src/mlx/pirep.py	(revision 437)
+++ src/mlx/pirep.py	(revision 743)
@@ -4,4 +4,6 @@
 import const
 import cPickle as pickle
+import datetime
+import time
 
 #------------------------------------------------------------------------------
@@ -19,4 +21,9 @@
 class PIREP(object):
     """A pilot's report of a flight."""
+    _flightTypes = { const.FLIGHTTYPE_SCHEDULED : "SCHEDULED",
+                     const.FLIGHTTYPE_OLDTIMER : "OT",
+                     const.FLIGHTTYPE_VIP : "VIP",
+                     const.FLIGHTTYPE_CHARTER : "CHARTER" }
+
     @staticmethod
     def _formatLine(timeStr, line):
@@ -24,4 +31,9 @@
         some other things."""
         return "[" + timeStr + "]-[" + line + "]"
+
+    @staticmethod
+    def formatTimestampForRPC(t):
+        """Format the given timestamp for RPC."""
+        return time.strftime("%Y-%m-%d %H:%M:%S", time.gmtime(t))
 
     @staticmethod
@@ -91,4 +103,29 @@
         self.faultLineIndexes = logger.faultLineIndexes
 
+    @property
+    def flightTypeText(self):
+        """Get the text representation of the flight type."""
+        return PIREP._flightTypes[self.flightType]
+
+    @property
+    def blockTimeStartText(self):
+        """Get the beginning of the block time in string format."""
+        return PIREP.formatTimestampForRPC(self.blockTimeStart)
+
+    @property
+    def flightTimeStartText(self):
+        """Get the beginning of the flight time in string format."""
+        return PIREP.formatTimestampForRPC(self.flightTimeStart)
+
+    @property
+    def flightTimeEndText(self):
+        """Get the end of the flight time in string format."""
+        return PIREP.formatTimestampForRPC(self.flightTimeEnd)
+
+    @property
+    def blockTimeEndText(self):
+        """Get the end of the block time in string format."""
+        return PIREP.formatTimestampForRPC(self.blockTimeEnd)
+
     def getACARSText(self):
         """Get the ACARS text.
@@ -152,2 +189,39 @@
             print u"Failed saving PIREP to %s: %s" % (path, error)
             return error
+
+    def _serialize(self):
+        """Serialize the PIREP for JSON-RPC."""
+        attrs = {}
+        attrs["log"] = self.getACARSText()
+        attrs["numPassengers"] = self.numPassengers
+        attrs["numCrew"] = self.numCrew
+        attrs["cargoWeight"] = self.cargoWeight
+        attrs["bagWeight"] = self.bagWeight
+        attrs["mailWeight"] = self.mailWeight
+        attrs["flightType"] = self.flightTypeText
+        attrs["online"] = 1 if self.online else 0
+        attrs["blockTimeStart"] = self.blockTimeStartText
+        attrs["blockTimeEnd"] = self.blockTimeEndText
+        attrs["flightTimeStart"] = self.flightTimeStartText
+        attrs["flightTimeEnd"] = self.flightTimeEndText
+        attrs["timeComment"] = self.getTimeComment()
+        attrs["fuelUsed"] = self.fuelUsed
+        attrs["departureRunway"] = self.departureRunway
+        attrs["arrivalRunway"] = self.arrivalRunway
+        attrs["departureMETAR"] = self.departureMETAR
+        attrs["arrivalMETAR"] = self.arrivalMETAR
+        attrs["filedCruiseLevel"] = self.filedCruiseAltitude / 100.0
+        attrs["cruiseLevel"] = self.cruiseAltitude / 100.0
+        attrs["sid"] = self.sid
+        attrs["route"] = self.route
+        attrs["star"] = self.star
+        attrs["approachType"] = self.approachType
+        attrs["comments"] = self.comments
+        attrs["flightDefects"] = self.flightDefects
+        attrs["ratingText"] = self.getRatingText()
+        attrs["rating"] = max(0.0, self.rating)
+        attrs["flownDistance"] = self.flownDistance
+        # FIXME: it should be stored in the PIREP when it is sent later
+        attrs["flightDate"] = datetime.date.today().strftime("%Y-%m-%d")
+
+        return ([], attrs)
Index: src/mlx/rpc.py
===================================================================
--- src/mlx/rpc.py	(revision 764)
+++ src/mlx/rpc.py	(revision 764)
@@ -0,0 +1,338 @@
+import const
+import rpccommon
+
+from common import MAVA_BASE_URL
+
+import jsonrpclib
+import hashlib
+import datetime
+
+#---------------------------------------------------------------------------------------
+
+class RPCObject(object):
+    """Base class for objects read from RPC calls.
+
+    It is possible to construct it from a dictionary."""
+    def __init__(self, value, instructions = {}):
+        """Construct the object.
+
+        value is the dictionary returned by the call.
+
+        info is a mapping from names to 'instructions' on what to do with the
+        corresponding values. If the instruction is None, it will be ignored.
+        If the instruction is a function, the value will be passed to it and
+        the return value will be stored in the object.
+
+        For all other names, the value will be stored as the same-named
+        attribute."""
+        for (key, value) in value.iteritems():
+            if key in instructions:
+                instruction = instructions[key]
+                if instruction is None:
+                    continue
+
+                value = instruction(value)
+            setattr(self, key, value)
+
+#---------------------------------------------------------------------------------------
+
+class Reply(RPCObject):
+    """The generic reply structure."""
+
+#---------------------------------------------------------------------------------------
+
+class BookedFlight(RPCObject):
+    """A booked flight."""
+    # FIXME: copied from web.BookedFlight
+    TYPECODE2TYPE = { "736"  : const.AIRCRAFT_B736,
+                      "73G"  : const.AIRCRAFT_B737,
+                      "738"  : const.AIRCRAFT_B738,
+                      "73H"  : const.AIRCRAFT_B738C,
+                      "733"  : const.AIRCRAFT_B733,
+                      "734"  : const.AIRCRAFT_B734,
+                      "735"  : const.AIRCRAFT_B735,
+                      "DH4"  : const.AIRCRAFT_DH8D,
+                      "762"  : const.AIRCRAFT_B762,
+                      "763"  : const.AIRCRAFT_B763,
+                      "CR2"  : const.AIRCRAFT_CRJ2,
+                      "F70"  : const.AIRCRAFT_F70,
+                      "LI2"  : const.AIRCRAFT_DC3,
+                      "TU3"  : const.AIRCRAFT_T134,
+                      "TU5"  : const.AIRCRAFT_T154,
+                      "YK4"  : const.AIRCRAFT_YK40,
+                      "146"  : const.AIRCRAFT_B462 }
+
+    # FIXME: copied from web.BookedFlight
+    @staticmethod
+    def _decodeAircraftType(typeCode):
+        """Decode the aircraft type from the given typeCode."""
+        if typeCode in BookedFlight.TYPECODE2TYPE:
+            return BookedFlight.TYPECODE2TYPE[typeCode]
+        else:
+            raise Exception("Invalid aircraft type code: '" + typeCode + "'")
+
+    # FIXME: copied from web.BookedFlight
+    @staticmethod
+    def getDateTime(date, time):
+        """Get a datetime object from the given textual date and time."""
+        return datetime.datetime.strptime(date + " " + time,
+                                          "%Y-%m-%d %H:%M:%S")
+
+    # The instructions for the construction
+    _instructions = {
+        "numPassengers" : int,
+        "numCrew" : int,
+        "bagWeight" : int,
+        "cargoWeight" : int,
+        "mailWeight" : int,
+        "aircraftType" : lambda value: BookedFlight._decodeAircraftType(value)
+        }
+
+    def __init__(self, value):
+        """Construct the booked flight object from the given RPC result
+        value."""
+        super(BookedFlight, self).__init__(value, BookedFlight._instructions)
+        self.departureTime = \
+          BookedFlight.getDateTime(self.date, self.departureTime)
+        self.arrivalTime = \
+          BookedFlight.getDateTime(self.date, self.arrivalTime)
+        if self.arrivalTime<self.departureTime:
+            self.arrivalTime += datetime.timedelta(days = 1)
+
+#---------------------------------------------------------------------------------------
+
+class Plane(rpccommon.Plane, RPCObject):
+    """An airplane in the fleet."""
+    _instructions = {
+        "status" : lambda value: rpccommon.Plane.str2status(value),
+        "gateNumber" : lambda value: value if value else None
+        }
+
+    def __init__(self, value):
+        """Construct the plane."""
+        RPCObject.__init__(self, value, instructions = Plane._instructions)
+
+#---------------------------------------------------------------------------------------
+
+class Fleet(rpccommon.Fleet):
+    """The fleet."""
+    def __init__(self, value):
+        """Construct the fleet."""
+        super(Fleet, self).__init__()
+        for planeValue in value:
+            self._addPlane(Plane(planeValue))
+
+#---------------------------------------------------------------------------------------
+
+class Registration(object):
+    """Data for registration."""
+    def __init__(self, surName, firstName, nameOrder,
+                 yearOfBirth, emailAddress, emailAddressPublic,
+                 vatsimID, ivaoID, phoneNumber, nationality, password):
+        """Construct the registration data."""
+        self.surName = surName
+        self.firstName = firstName
+        self.nameOrder = nameOrder
+        self.yearOfBirth = yearOfBirth
+        self.emailAddress = emailAddress
+        self.emailAddressPublic = 1 if emailAddressPublic is True else \
+          0 if emailAddressPublic is False else emailAddressPublic
+        self.vatsimID = "" if vatsimID is None else vatsimID
+        self.ivaoID = "" if ivaoID is None else ivaoID
+        self.phoneNumber = phoneNumber
+        self.nationality = nationality
+        self.password = password
+
+#---------------------------------------------------------------------------------------
+
+class RPCException(Exception):
+    """An exception thrown by RPC operations."""
+    def __init__(self, result, message = None):
+        """Construct the exception."""
+        self._result = result
+        if message is None:
+            message = "RPC call failed with result code: %d" % (result,)
+        super(RPCException, self).__init__(message)
+
+    @property
+    def result(self):
+        """Get the result code."""
+        return self._result
+
+#---------------------------------------------------------------------------------------
+
+class Client(object):
+    """The RPC client interface."""
+    # Result code: OK
+    RESULT_OK = 0
+
+    # Result code: the login has failed
+    RESULT_LOGIN_FAILED = 1
+
+    # Result code: the given session ID is unknown (it might have expired).
+    RESULT_SESSION_INVALID = 2
+
+    # Result code: some database error
+    RESULT_DATABASE_ERROR = 3
+
+    # Result code: invalid data
+    RESULT_INVALID_DATA = 4
+
+    # Result code: the flight does not exist
+    RESULT_FLIGHT_NOT_EXISTS = 101
+
+    # Result code: the flight has already been reported.
+    RESULT_FLIGHT_ALREADY_REPORTED = 102
+
+    # Result code: a user with the given e-mail address already exists
+    RESULT_EMAIL_ALREADY_REGISTERED = 103
+
+    def __init__(self, getCredentialsFn):
+        """Construct the client."""
+        self._getCredentialsFn = getCredentialsFn
+
+        self._server = jsonrpclib.Server(MAVA_BASE_URL + "/jsonrpc.php")
+
+        self._userName = None
+        self._passwordHash = None
+        self._sessionID = None
+        self._loginCount = 0
+
+    @property
+    def valid(self):
+        """Determine if the client is valid, i.e. there is a session ID
+        stored."""
+        return self._sessionID is not None
+
+    def setCredentials(self, userName, password):
+        """Set the credentials for future logins."""
+
+        self._userName = userName
+
+        md5 = hashlib.md5()
+        md5.update(password)
+        self._passwordHash = md5.hexdigest()
+
+        self._sessionID = None
+
+    def register(self, registrationData):
+        """Register with the given data.
+
+        Returns a tuple of:
+        - the error code,
+        - the PID if there is no error."""
+        reply = Reply(self._server.register(registrationData))
+
+        return (reply.result,
+                reply.value["pid"] if reply.result==Client.RESULT_OK else None)
+
+    def login(self):
+        """Login using the given previously set credentials.
+
+        The session ID is stored in the object and used for later calls.
+
+        Returns the name of the pilot on success, or None on error."""
+        self._sessionID = None
+
+        reply = Reply(self._server.login(self._userName, self._passwordHash))
+        if reply.result == Client.RESULT_OK:
+            self._loginCount += 1
+            self._sessionID = reply.value["sessionID"]
+            return (reply.value["name"], reply.value["rank"])
+        else:
+            return None
+
+    def getFlights(self):
+        """Get the flights available for performing."""
+        flights = []
+
+        value = self._performCall(lambda sessionID:
+                                  self._server.getFlights(sessionID))
+        for flightData in value:
+            flights.append(BookedFlight(flightData))
+
+        flights.sort(cmp = lambda flight1, flight2:
+                     cmp(flight1.departureTime, flight2.departureTime))
+
+        return flights
+
+    def getEntryExamStatus(self):
+        """Get the status of the exams needed for joining MAVA."""
+        value = self._performCall(lambda sessionID:
+                                  self._server.getEntryExamStatus(sessionID))
+        return (value["entryExamPassed"], value["entryExamLink"],
+                value["checkFlightStatus"])
+
+    def getFleet(self):
+        """Query and return the fleet."""
+        value = self._performCall(lambda sessionID:
+                                  self._server.getFleet(sessionID))
+
+        return Fleet(value)
+
+    def updatePlane(self, tailNumber, status, gateNumber):
+        """Update the state and position of the plane with the given tail
+        number."""
+        status = rpccommon.Plane.status2str(status)
+        self._performCall(lambda sessionID:
+                          self._server.updatePlane(sessionID, tailNumber,
+                                                   status, gateNumber))
+
+    def addPIREP(self, flightID, pirep):
+        """Add the PIREP for the given flight."""
+        (result, _value) = \
+          self._performCall(lambda sessionID:
+                            self._server.addPIREP(sessionID, flightID, pirep),
+                            acceptResults = [Client.RESULT_FLIGHT_ALREADY_REPORTED,
+                                             Client.RESULT_FLIGHT_NOT_EXISTS])
+        return result
+
+    def updateOnlineACARS(self, acars):
+        """Update the online ACARS from the given data."""
+        self._performCall(lambda sessionID:
+                          self._server.updateOnlineACARS(sessionID, acars))
+
+    def _performCall(self, callFn, acceptResults = []):
+        """Perform a call using the given call function.
+
+        acceptResults should be a list of result codes that should be accepted
+        besides RESULT_OK. If this list is not empty, the returned value is a
+        tuple of the result code and the corresponding value. Otherwise only
+        RESULT_OK is accepted, and the value is returned.
+
+        All other error codes are converted to exceptions."""
+        numAttempts = 0
+        while True:
+            reply = Reply(callFn(self._ensureSession()))
+            numAttempts += 1
+            result = reply.result
+            if result==Client.RESULT_SESSION_INVALID:
+                self._sessionID = None
+                if numAttempts==3:
+                    raise RPCException(result)
+            elif result!=Client.RESULT_OK and result not in acceptResults:
+                raise RPCException(result)
+            elif acceptResults:
+                return (result, reply.value)
+            else:
+                return reply.value
+
+    def _ensureSession(self):
+        """Ensure that there is a valid session ID."""
+        while self._sessionID is None:
+            if self._userName is not None and self._passwordHash is not None:
+                if not self.login():
+                    self._userName = self._passwordHash = None
+
+            if self._userName is None or self._passwordHash is None:
+                (self._userName, password) = self._getCredentialsFn()
+                if self._userName is None:
+                    raise RPCException(Client.RESULT_LOGIN_FAILED)
+
+                md5 = hashlib.md5()
+                md5.update(password)
+                self._passwordHash = md5.hexdigest()
+
+        return self._sessionID
+
+#---------------------------------------------------------------------------------------
